Index: inundation/ga/storm_surge/analytical solutions/Analytical solution_oblique_shock.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Analytical solution_oblique_shock.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Analytical solution_oblique_shock.py	(revision 774)
@@ -88,5 +88,5 @@
 #Initial condition
 h = 0.5
-domain.set_quantity('level', Constant_height(x_slope, h) )
+domain.set_quantity('stage', Constant_height(x_slope, h) )
 
 
Index: inundation/ga/storm_surge/analytical solutions/Analytical solution_wave_runup.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Analytical solution_wave_runup.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Analytical solution_wave_runup.py	(revision 774)
@@ -115,5 +115,5 @@
     return [stage, uh, vh]
 
-def boundary_level(t):
+def boundary_stage(t):
     x = -200
     return stage_setup(x,t)
@@ -137,5 +137,5 @@
 
 #Set the water depth
-def level(x,y):
+def stage(x,y):
     z = x_slope(x,y)
     n = x.shape[0]
@@ -149,5 +149,5 @@
     return w   
 
-domain.set_quantity('level', level)
+domain.set_quantity('stage', stage)
 
 
@@ -155,5 +155,5 @@
 #Set up boundary conditions
 Br = Reflective_boundary(domain)
-Bw = Time_boundary(domain, boundary_level)
+Bw = Time_boundary(domain, boundary_stage)
 domain.set_boundary({'left': Bw, 'external': Br})
 
@@ -165,5 +165,5 @@
 for t in domain.evolve(yieldstep = 1., finaltime = 100):
     domain.write_time()
-    print boundary_level(domain.time)
+    print boundary_stage(domain.time)
     
 print 'That took %.2f seconds' %(time.time()-t0)
Index: inundation/ga/storm_surge/analytical solutions/Analytical_solution_MacDonald_import_mesh.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Analytical_solution_MacDonald_import_mesh.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Analytical_solution_MacDonald_import_mesh.py	(revision 774)
@@ -75,5 +75,5 @@
 #---------------------------------------------------------
 #Decide which quantities are to be stored at each timestep
-domain.quantities_to_be_stored = ['level', 'xmomentum', 'ymomentum']
+domain.quantities_to_be_stored = ['stage', 'xmomentum', 'ymomentum']
 
 #Reduction operation for get_vertex_values              
@@ -99,5 +99,5 @@
 #Initial condition
 domain.set_quantity('elevation', 0.0)
-domain.set_quantity('level', 0.2)
+domain.set_quantity('stage', 0.2)
     
 #-----------------
Index: inundation/ga/storm_surge/analytical solutions/Analytical_solution_Sampson_import_mesh.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Analytical_solution_Sampson_import_mesh.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Analytical_solution_Sampson_import_mesh.py	(revision 774)
@@ -92,6 +92,6 @@
 
 
-#Set the water level
-def level(x,y):
+#Set the water stage
+def stage(x,y):
     z = x_slope(x,y)
     n = x.shape[0]
@@ -105,5 +105,5 @@
     return h   
 
-domain.set_quantity('level', level)
+domain.set_quantity('stage', stage)
 
 
Index: inundation/ga/storm_surge/analytical solutions/Analytical_solution_Yoon_import_mesh.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Analytical_solution_Yoon_import_mesh.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Analytical_solution_Yoon_import_mesh.py	(revision 774)
@@ -74,6 +74,6 @@
 domain.set_quantity('elevation', x_slope)
 
-#Set the initial water level
-def level(x,y):
+#Set the initial water stage
+def stage(x,y):
     z = x_slope(x,y)
     n = x.shape[0]
@@ -87,5 +87,5 @@
     return h   
 
-domain.set_quantity('level', level)
+domain.set_quantity('stage', stage)
 
 
Index: inundation/ga/storm_surge/analytical solutions/Analytical_solution_contracting_channel_import_mesh.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Analytical_solution_contracting_channel_import_mesh.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Analytical_solution_contracting_channel_import_mesh.py	(revision 774)
@@ -46,5 +46,5 @@
 
 #Decide which quantities are to be stored at each timestep
-domain.quantities_to_be_stored = ['level', 'xmomentum', 'ymomentum']
+domain.quantities_to_be_stored = ['stage', 'xmomentum', 'ymomentum']
 
 #Reduction operation for get_vertex_values              
@@ -63,5 +63,5 @@
 #Initial condition
 domain.set_quantity('elevation', 0.0)
-domain.set_quantity('level', 0.2)
+domain.set_quantity('stage', 0.2)
     
 
Index: inundation/ga/storm_surge/analytical solutions/Hobart.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Hobart.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Hobart.py	(revision 774)
@@ -53,5 +53,5 @@
 #Initial condition
 #   Throughout
-domain.set_quantity('level', 0.)
+domain.set_quantity('stage', 0.)
 
 #    Within polygon region
@@ -67,7 +67,7 @@
 
 zp = domain.get_quantity('elevation', location='centroids', indexes=indices)
-#        Set the level to bed elevation plus depth for all triangle vertices in the polygon region
+#        Set the stage to bed elevation plus depth for all triangle vertices in the polygon region
 
-domain.set_quantity('level', zp+depth, location='centroids', indexes=indices) 
+domain.set_quantity('stage', zp+depth, location='centroids', indexes=indices) 
 
 
@@ -80,5 +80,5 @@
 #for i in indices:
 #    w[i, :] = z[i, :] + depth
-#domain.set_quantity('level', w)
+#domain.set_quantity('stage', w)
 
 
@@ -91,5 +91,5 @@
 #---------------------------------------------------------
 #Decide which quantities are to be stored at each timestep
-domain.quantities_to_be_stored = ['level', 'xmomentum', 'ymomentum']
+domain.quantities_to_be_stored = ['stage', 'xmomentum', 'ymomentum']
 
 #----------------------------
Index: inundation/ga/storm_surge/analytical solutions/Malpasset_new.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Malpasset_new.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Malpasset_new.py	(revision 774)
@@ -49,5 +49,5 @@
 #-----------------
 #Initial condition
-domain.set_quantity('level', 0.)
+domain.set_quantity('stage', 0.)
 
 #-------------------------------------
Index: inundation/ga/storm_surge/analytical solutions/Sydney.py
===================================================================
--- inundation/ga/storm_surge/analytical solutions/Sydney.py	(revision 773)
+++ inundation/ga/storm_surge/analytical solutions/Sydney.py	(revision 774)
@@ -54,6 +54,6 @@
 domain.set_quantity('elevation', x_slope)
 
-#Set the initial water level
-def level(x,y):
+#Set the initial water stage
+def stage(x,y):
     z = x_slope(x,y)
     n = x.shape[0]
@@ -61,8 +61,8 @@
     return h   
 
-domain.set_quantity('level', level)
+domain.set_quantity('stage', stage)
 p0 = [[334429.024416, 6251238.11488],[334428.532417, 6251234.42489],
       [334432.468407, 6251233.93289],[334431.730409, 6251238.36088]]
-domain.set_quantity('level',Polygon_function([(p0,10000.0)]))
+domain.set_quantity('stage',Polygon_function([(p0,10000.0)]))
 
 ############
Index: inundation/ga/storm_surge/examples/beach.py
===================================================================
--- inundation/ga/storm_surge/examples/beach.py	(revision 773)
+++ inundation/ga/storm_surge/examples/beach.py	(revision 774)
@@ -113,6 +113,6 @@
 print 'That took %.2f seconds' %(time.time()-t0)
 		      
-print 'Set level'    		      
-domain.set_quantity('level', 
+print 'Set stage'    		      
+domain.set_quantity('stage', 
 		    Polygon_function( [(water, -1.5), 
 		    (land, -10)] )) 
Index: inundation/ga/storm_surge/examples/run_tsh.py
===================================================================
--- inundation/ga/storm_surge/examples/run_tsh.py	(revision 773)
+++ inundation/ga/storm_surge/examples/run_tsh.py	(revision 774)
@@ -115,8 +115,8 @@
     #domain.set_region(Set_region('mound', 'elevation', 100, location='unique vertices'))
     domain.set_region(Add_value_to_region('mound', 'elevation', 100, location='unique vertices', initial_quantity='elevation'))
-    domain.set_region(Add_value_to_region('reservoir', 'level', 100.0,initial_quantity='elevation'))
+    domain.set_region(Add_value_to_region('reservoir', 'stage', 100.0,initial_quantity='elevation'))
     
     #print domain.quantities['elevation'].vertex_values
-    #print domain.quantities['level'].vertex_values
+    #print domain.quantities['stage'].vertex_values
          
     domain.check_integrity()