Index: /inundation/ga/storm_surge/pyvolution/config.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/config.py	(revision 843)
+++ /inundation/ga/storm_surge/pyvolution/config.py	(revision 844)
@@ -44,7 +44,4 @@
 rho_w = 1023   #Fluid density [kg/m^3] (rho_w = 1023 for salt water)
 
-        
-
-
 
 
@@ -59,7 +56,7 @@
 
 if sys.platform == 'win32':
-    data_dir = 'C:\grohm_output'
+    default_datadir = 'C:\grohm_output'
 else:    
-    data_dir = os.path.expanduser('~'+os.sep+'grohm_output')
+    default_datadir = os.path.expanduser('~'+os.sep+'grohm_output')
 
 
Index: /inundation/ga/storm_surge/pyvolution/data_manager.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/data_manager.py	(revision 843)
+++ /inundation/ga/storm_surge/pyvolution/data_manager.py	(revision 844)
@@ -123,11 +123,13 @@
 
 	
-def create_filename(filename, format, size, time=None):
+def create_filename(datadir, filename, format, size=None, time=None):
 
     import os
-    from config import data_dir
-
+    #from config import data_dir
            
-    FN = check_dir(data_dir) + filename + '_size%d' %size
+    FN = check_dir(datadir) + filename
+    
+    if size is not None:	   
+    	FN += '_size%d' %size
 
     if time is not None:
@@ -138,5 +140,5 @@
     
 
-def get_files(filename, format, size):
+def get_files(datadir, filename, format, size):
     """Get all file (names) with gven name, size and format
     """
@@ -145,8 +147,7 @@
 
     import os
-    from config import data_dir
-
+    #from config import data_dir
            
-    dir = check_dir(data_dir)
+    dir = check_dir(datadir)
 
     pattern = dir + os.sep + filename + '_size=%d*.%s' %(size, format)
@@ -168,5 +169,10 @@
 
         #Create filename
-        self.filename = create_filename(domain.get_name(), extension, len(domain))
+        #self.filename = create_filename(domain.get_datadir(), 
+	#	domain.get_name(), extension, len(domain))
+	
+        self.filename = create_filename(domain.get_datadir(), 
+			domain.get_name(), extension)	
+		
         self.timestep = 0
         self.number_of_volumes = len(domain)
@@ -629,5 +635,5 @@
 
     #Get NetCDF
-    FN = create_filename(basefilename, 'sww', size)
+    FN = create_filename('.', basefilename, 'sww', size)
     print 'Reading from ', FN
     fid = NetCDFFile(FN, 'r')  #Open existing file for read
@@ -653,5 +659,5 @@
         
     #Write obj for bathymetry
-    FN = create_filename(basefilename, 'obj', size)        
+    FN = create_filename('.', basefilename, 'obj', size)        
     write_obj(FN,xx,yy,zz)
 
@@ -671,5 +677,5 @@
         #Write obj for variable data
         #FN = create_filename(basefilename, 'obj', size, time=t)
-        FN = create_filename(basefilename[:5], 'obj', size, time=t)   
+        FN = create_filename('.', basefilename[:5], 'obj', size, time=t)   
         write_obj(FN,xx,yy,zz)
 
@@ -677,4 +683,5 @@
 def dat2obj(basefilename):
     """Convert line based data output to obj
+    FIXME: Obsolete?
     """
 
Index: /inundation/ga/storm_surge/pyvolution/domain.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/domain.py	(revision 843)
+++ /inundation/ga/storm_surge/pyvolution/domain.py	(revision 844)
@@ -68,5 +68,7 @@
         self.starttime = None
 	
-        #Checkpointing		
+        #Checkpointing and storage		
+        from config import default_datadir
+	self.datadir = default_datadir 
 	self.filename = 'domain'
 	self.checkpoint = False
@@ -311,4 +313,12 @@
         self.filename = name    
 
+    def get_datadir(self):
+        return self.datadir    	
+			
+    def set_datadir(self, name):
+        self.datadir = name    	
+
+	
+
     #def set_defaults(self):
     #    """Set default values for uninitialised quantities.
@@ -336,5 +346,4 @@
         """
 
-        #import data_manager
         from config import min_timestep, max_timestep, epsilon
 
Index: /inundation/ga/storm_surge/pyvolution/generic_boundary_conditions.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/generic_boundary_conditions.py	(revision 843)
+++ /inundation/ga/storm_surge/pyvolution/generic_boundary_conditions.py	(revision 844)
@@ -123,5 +123,4 @@
 
     No spatial info assumed.
-    FIXME: Soon to be Obsolete
     """
 
Index: /inundation/ga/storm_surge/pyvolution/test_generic_boundary_conditions.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/test_generic_boundary_conditions.py	(revision 843)
+++ /inundation/ga/storm_surge/pyvolution/test_generic_boundary_conditions.py	(revision 844)
@@ -179,28 +179,4 @@
 
 
-    def test_fileboundary_time_and_space(self):
-        """Test that boundary values can be read from file and interpolated
-        Include both time and space
-        """
-
-        from domain import Domain
-        from quantity import Quantity
-
-	
-	#Create sww file of simple propagation from left to right 
-	#through rectangular domain: domain1
-	
-	#Create an oblique domain, 
-	#rectangular with left side at an angle but fully contained within 
-	#previous rectangular domain and called it domain2
-	
-	#Use output from domain1 as spatio-temporal boundary for domain2
-        #and verify that results at right hand side are close.	
-
-	
-	
-	
-        #print 'File boundary_time_and_space not yet implemented'
-
     def test_fileboundary_exception(self):
         """Test that boundary object complians if number of
Index: /inundation/ga/storm_surge/pyvolution/util.py
===================================================================
--- /inundation/ga/storm_surge/pyvolution/util.py	(revision 843)
+++ /inundation/ga/storm_surge/pyvolution/util.py	(revision 844)
@@ -110,4 +110,7 @@
     time only, i.e  no spatial dependency!!!!!
     When that is needed we can use the least_squares interpolation.
+    
+    #FIXME: This should work with netcdf (e.g. sww) and thus render the 
+    #spatio-temporal boundary condition in shallow water fully general
     """
 